// automatically generated by spin2cpp v3.8.6-beta on Fri Aug 24 19:10:43 2018
// command line: spin2cpp --ccode --main -L /Users/altergator/Documents/PropSpinCode/SpinObjects apa102-Demo.spin 

// The Standalone SPI Spin engine
/* 
Object file:    FullDuplexSerial.spin
Version:        1.2.1
Date:           2006 - 2011
Author:         Chip Gracey, Jeff Martin, Daniel Harris
Company:        Parallax Semiconductor
Email:          dharris@parallaxsemiconductor.com
Licensing:      MIT License - see end of file for terms of use.

Description:
This driver, once started, implements a serial port in one cog.

Revision History:
v1.2.1 - 5/1/2011 Added extra comments and demonstration code to bring up
                   to gold standard.
v1.2 - 5/7/2009 Fixed bug in dec method causing largest negative value
                (-2,147,483,648) to be output as -0.
v1.1 - 3/1/2006 First official release.

 
=============================================
        Connection Diagram
=============================================

        ┌─────────┐   
        │         │         
        │    rxPin├─── TTL level RX line
        │    txPin├─── TTL level TX line
        │         │   
        └─────────┘           
         Propeller
            MCU
          (P8X32A)

Components:
N/A

=============================================                  
 */
#include <stdlib.h>
#include <propeller.h>
#include "FullDuplexSerial.h"

#ifdef __GNUC__
#define INLINE__ static inline
#define Yield__() __asm__ volatile( "" ::: "memory" )
#else
#define INLINE__ static
#define Yield__()
#define waitcnt(n) _waitcnt(n)
#define coginit(id, code, par) _coginit((unsigned)(par)>>2, (unsigned)(code)>>2, id)
#define cognew(code, par) coginit(0x8, (code), (par))
#define cogstop(i) _cogstop(i)
#endif

INLINE__ int32_t Rotl__(uint32_t a, uint32_t b) { return (a<<b) | (a>>(32-b)); }
INLINE__ int32_t Rotr__(uint32_t a, uint32_t b) { return (a>>b) | (a<<(32-b)); }
INLINE__ int32_t Lookup__(int32_t x, int32_t b, int32_t a[], int32_t n) { int32_t i = (x)-(b); return ((unsigned)i >= n) ? 0 : (a)[i]; }

static char dat[] = {
  0xf0, 0xa9, 0xbc, 0xa0, 0x10, 0xa8, 0xfc, 0x80, 0x54, 0xaa, 0xbc, 0x08, 0x01, 0xb2, 0xfc, 0xa0, 
  0x55, 0xb2, 0xbc, 0x2c, 0x04, 0xa8, 0xfc, 0x80, 0x54, 0xaa, 0xbc, 0x08, 0x01, 0xbe, 0xfc, 0xa0, 
  0x55, 0xbe, 0xbc, 0x2c, 0x04, 0xa8, 0xfc, 0x80, 0x54, 0xae, 0xbc, 0x08, 0x04, 0xa8, 0xfc, 0x80, 
  0x54, 0xb0, 0xbc, 0x08, 0x04, 0xa8, 0xfc, 0x80, 0x54, 0xb4, 0xbc, 0x08, 0x5a, 0xc0, 0xbc, 0xa0, 
  0x10, 0xc0, 0xfc, 0x80, 0x04, 0xae, 0x7c, 0x62, 0x02, 0xae, 0x7c, 0x61, 0x5f, 0xe8, 0x9b, 0x68, 
  0x5f, 0xec, 0xab, 0x68, 0x33, 0xc8, 0xfc, 0xa0, 0x64, 0xbc, 0xbc, 0x5c, 0x01, 0xae, 0x7c, 0x62, 
  0xf2, 0xb3, 0x3c, 0x61, 0x16, 0x00, 0x64, 0x5c, 0x09, 0xb8, 0xfc, 0xa0, 0x58, 0xba, 0xbc, 0xa0, 
  0x01, 0xba, 0xfc, 0x28, 0xf1, 0xbb, 0xbc, 0x80, 0x58, 0xba, 0xbc, 0x80, 0x64, 0xbc, 0xbc, 0x5c, 
  0x5d, 0xa8, 0xbc, 0xa0, 0xf1, 0xa9, 0xbc, 0x84, 0x00, 0xa8, 0x7c, 0xc1, 0x1f, 0x00, 0x4c, 0x5c, 
  0xf2, 0xb3, 0x3c, 0x61, 0x01, 0xb6, 0xfc, 0x30, 0x1e, 0xb8, 0xfc, 0xe4, 0x17, 0xb6, 0xfc, 0x28, 
  0xff, 0xb6, 0xfc, 0x60, 0x01, 0xae, 0x7c, 0x62, 0xff, 0xb6, 0xd4, 0x6c, 0xf0, 0xab, 0xbc, 0x08, 
  0x5a, 0xaa, 0xbc, 0x80, 0x55, 0xb6, 0x3c, 0x00, 0x5a, 0xaa, 0xbc, 0x84, 0x01, 0xaa, 0xfc, 0x80, 
  0x0f, 0xaa, 0xfc, 0x60, 0xf0, 0xab, 0x3c, 0x08, 0x16, 0x00, 0x7c, 0x5c, 0x5e, 0xc8, 0xbc, 0x5c, 
  0xf0, 0xa9, 0xbc, 0xa0, 0x08, 0xa8, 0xfc, 0x80, 0x54, 0xaa, 0xbc, 0x08, 0x04, 0xa8, 0xfc, 0x80, 
  0x54, 0xac, 0xbc, 0x08, 0x56, 0xaa, 0x3c, 0x86, 0x33, 0x00, 0x68, 0x5c, 0x60, 0xac, 0xbc, 0x80, 
  0x56, 0xc2, 0xbc, 0x00, 0x60, 0xac, 0xbc, 0x84, 0x01, 0xac, 0xfc, 0x80, 0x0f, 0xac, 0xfc, 0x60, 
  0x54, 0xac, 0x3c, 0x08, 0x00, 0xc3, 0xfc, 0x68, 0x02, 0xc2, 0xfc, 0x2c, 0x01, 0xc2, 0xfc, 0x68, 
  0x0b, 0xc4, 0xfc, 0xa0, 0xf1, 0xc7, 0xbc, 0xa0, 0x04, 0xae, 0x7c, 0x62, 0x02, 0xae, 0x7c, 0x61, 
  0x01, 0xc2, 0xe0, 0x6c, 0x01, 0xc2, 0xfc, 0x29, 0x5f, 0xe8, 0xab, 0x70, 0x5f, 0xec, 0x97, 0x74, 
  0x58, 0xc6, 0xbc, 0x80, 0x5e, 0xc8, 0xbc, 0x5c, 0x63, 0xa8, 0xbc, 0xa0, 0xf1, 0xa9, 0xbc, 0x84, 
  0x00, 0xa8, 0x7c, 0xc1, 0x4d, 0x00, 0x4c, 0x5c, 0x46, 0xc4, 0xfc, 0xe4, 0x33, 0x00, 0x7c, 0x5c, 
};
int32_t FullDuplexSerial_Start(FullDuplexSerial *self, int32_t rxPin, int32_t txPin, int32_t mode, int32_t baudrate)
{
  int32_t okay = 0;
  /* 
     Start serial driver - starts a cog
     
  
     Parameters: rxPin    = Propeller pin to set up as RX-ing pin.  Range = 0 - 31
                 txPin    = Propeller pin to set up as TX-ing pin.  Range = 0 - 31
                 mode     = bitwise mode configuration variable, see mode bit description below.
                 baudrate = baud rate to transmit bits at.
     
     mode bit 0 = invert rx
     mode bit 1 = invert tx
     mode bit 2 = open-drain/source tx
     mode bit 3 = ignore tx echo on rx
  
     return: Numeric value of the cog(1-8) that was started, false(0) if no cog is available.
  
     example usage: serial.start(31, 30, %0000, 9_600)
  
     expected outcome of example usage call: Starts a serial port on Propller pins 30 and 31.
                                             The serial port does not invert the RX and TX data,
                                             no open-drain/source on the TX pin, does not ignore
                                             data echoed on RX pin, at 9,600 baud.
   */
  // make sure the driver isnt already running
  FullDuplexSerial_Stop(self);
  // zero out the buffer pointers
  memset( (void *)(&self->rx_head), 0, sizeof(int32_t)*4);
  // copy the start parameters to this objects pin variables
  self->rx_pin = rxPin;
  self->tx_pin = txPin;
  self->rxtx_mode = mode;
  // number of clock ticks per bit for the desired baudrate
  self->bit_ticks = CLKFREQ / baudrate;
  // save the address of the receive buffer
  self->buffer_ptr = (int32_t)(self->rx_buffer);
  // start the new cog now, assembly cog at "entry" label.
  okay = self->cog = cognew((int32_t)(((int32_t *)&dat[0])), (int32_t)(&self->rx_head)) + 1;
  return okay;
}

void FullDuplexSerial_Stop(FullDuplexSerial *self)
{
  int32_t 	_tmp__0009;
  /* 
     Stop serial driver if it has already been started - frees the cog
  
     Parameters: none
     return:     none
  
     example usage: serial.stop
  
     expected outcome of example usage call: Stops an already started serial port.
   */
  if (self->cog) {
    // if the driver is already running, stop the cog
    cogstop(( ( (_tmp__0009 = self->cog), (self->cog = 0) ), _tmp__0009 ) - 1);
  }
  // zero out configuration variables
  memset( (void *)(&self->rx_head), 0, sizeof(int32_t)*9);
}

void FullDuplexSerial_RxFlush(FullDuplexSerial *self)
{
  /* 
     Continuously pops the head of the receive buffer until no bytes remain.
     
     Parameters: none
     return:     none
  
     example usage: serial.RxFlush
  
     expected outcome of example usage call: Receive bffer will be cleared.
   */
  while (FullDuplexSerial_RxCheck(self) >= 0) {
    Yield__();
  }
}

// Call RxCheck until buffer is empty
int32_t FullDuplexSerial_RxCheck(FullDuplexSerial *self)
{
  int32_t rxByte = 0;
  /* 
     Check if a byte is waiting in the receive buffer and return the byte if one is there,
     does NOT block (never waits).
  
     Parameters: none
     return:     If no byte, then return(-1).  If byte, then return(byte).
  
     example usage: serial.RxCheck
  
     expected outcome of example usage call: Return a byte if one is available, but dont wait
                                             for a byte to come in.
   */
  // make rxbyte = -1
  (rxByte--);
  if (self->rx_tail != self->rx_head) {
    // if a byte is in the buffer, then
    //  grab it and store in rxByte
    rxByte = self->rx_buffer[self->rx_tail];
    //  advance the buffer pointer
    self->rx_tail = (self->rx_tail + 1) & 0xf;
  }
  return rxByte;
}

int32_t FullDuplexSerial_RxTime(FullDuplexSerial *self, int32_t ms)
{
  int32_t 	t;
  int32_t rxByte = 0;
  /* 
     Wait ms milliseconds for a byte to be received 
  
     Parameters: ms = number of milliseconds to wait for a byte to be received.
     return:     If no byte, then return(-1).  If byte, then return(byte).
  
     example usage: serial.RxTime(500)
  
     expected outcome of example usage call: Wait half a second (500 ms) for a byte to be received.
   */
  // take note of the current time
  t = CNT;
  while (!(((rxByte = FullDuplexSerial_RxCheck(self)) >= 0) || (((CNT - t) / (CLKFREQ / 1000)) > ms))) {
    Yield__();
  }
  return rxByte;
}

int32_t FullDuplexSerial_Rx(FullDuplexSerial *self)
{
  int32_t rxByte = 0;
  /* 
     Receive byte (may wait for byte)
     returns $00..$FF
  
     Parameters: none
     return:     received byte
  
     example usage: serial.Rx
  
     expected outcome of example usage call: Wait until a byte has been received, then return that byte.
   */
  while ((rxByte = FullDuplexSerial_RxCheck(self)) < 0) {
    Yield__();
  }
  return rxByte;
}

// return the byte, wait while the buffer is empty
void FullDuplexSerial_Tx(FullDuplexSerial *self, int32_t txByte)
{
  /* 
     Places a byte into the transmit buffer for transmission (may wait for room in buffer).
  
     Parameters: txByte = the byte to be transmitted
     return:     none
  
     example usage: serial.Tx($0D)
  
     expected outcome of example usage call: Transmits the byte $0D serially on the txPin
   */
  while (!(self->tx_tail != ((self->tx_head + 1) & 0xf))) {
    Yield__();
  }
  // wait until the buffer has room                        
  // place the byte into the buffer
  self->tx_buffer[self->tx_head] = txByte;
  // advance the buffer's pointer
  self->tx_head = (self->tx_head + 1) & 0xf;
  if (self->rxtx_mode & 0x8) {
    // if ignoring rx echo
    //   receive the echoed byte and discard
    FullDuplexSerial_Rx(self);
  }
}

void FullDuplexSerial_Str(FullDuplexSerial *self, int32_t stringPtr)
{
  int32_t 	_idx__0010;
  /* 
     Transmit a string of bytes
  
     Parameters: stringPtr = the pointer address of the null-terminated string to be sent
     return:     none
  
     example usage: serial.Str(@test_string)
  
     expected outcome of example usage call: Transmits each byte of a string at the address some_string.
   */
  for(_idx__0010 = strlen((const char *)stringPtr); _idx__0010 != 0; --_idx__0010) {
    // Transmit each byte in the string
    FullDuplexSerial_Tx(self, ((char *)(stringPtr++))[0]);
  }
}

int32_t FullDuplexSerial_Dec(FullDuplexSerial *self, int32_t value)
{
  int32_t 	i, x, _idx__0011;
  int32_t result = 0;
  /* 
     Transmit the ASCII string equivalent of a decimal value
  
     Parameters: dec = the numeric value to be transmitted
     return:     none
  
     example usage: serial.Dec(-1_234_567_890)
  
     expected outcome of example usage call: Will print the string "-1234567890" to a listening terminal.
   */
  // Check for max negative
  x = -(value == (int32_t)0x80000000U);
  if (value < 0) {
    // If negative, make positive; adjust for max negative
    value = abs((value + x));
    // and output sign
    FullDuplexSerial_Tx(self, '-');
  }
  // Initialize divisor
  i = 1000000000;
  for(_idx__0011 = 0; _idx__0011 < 10; _idx__0011++) {
    // Loop for 10 digits
    if (value >= i) {
      // If non-zero digit, output digit; adjust for max negative
      FullDuplexSerial_Tx(self, ((value / i) + '0') + (x * -(i == 1)));
      // and digit from value
      value = value % i;
      // flag non-zero found
      result = -1;
    } else {
      if ((result) || (i == 1)) {
        // If zero digit (or only digit) output it
        FullDuplexSerial_Tx(self, '0');
      }
    }
    // Update divisor
    i = i / 10;
  }
  return result;
}

void FullDuplexSerial_Hex(FullDuplexSerial *self, int32_t value, int32_t digits)
{
  int32_t 	_idx__0012;
  static int32_t look__0014[] = {48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 65, 66, 67, 68, 69, 70, };

  /* 
     Transmit the ASCII string equivalent of a hexadecimal number
  
     Parameters: value = the numeric hex value to be transmitted
                 digits = the number of hex digits to print                 
     return:     none
  
     example usage: serial.Hex($AA_FF_43_21, 8)
  
     expected outcome of example usage call: Will print the string "AAFF4321" to a listening terminal.
   */
  value = value << ((8 - digits) << 2);
  for(_idx__0012 = digits; _idx__0012 != 0; --_idx__0012) {
    // do it for the number of hex digits being transmitted
    //  Transmit the ASCII value of the hex characters
    FullDuplexSerial_Tx(self, Lookup__(((value = Rotl__(value, 4)) & 0xf), 0, look__0014, 16));
  }
}

void FullDuplexSerial_Bin(FullDuplexSerial *self, int32_t value, int32_t digits)
{
  int32_t 	_idx__0013;
  /* 
     Transmit the ASCII string equivalent of a binary number
     
     Parameters: value = the numeric binary value to be transmitted
                 digits = the number of binary digits to print                 
     return:     none
  
     example usage: serial.Bin(%1110_0011_0000_1100_1111_1010_0101_1111, 32)
  
     expected outcome of example usage call: Will print the string "11100011000011001111101001011111" to a listening terminal.
   */
  value = value << (32 - digits);
  for(_idx__0013 = digits; _idx__0013 != 0; --_idx__0013) {
    // Transmit the ASCII value of each binary digit
    FullDuplexSerial_Tx(self, ((value = Rotl__(value, 1)) & 0x1) + '0');
  }
}

/* 
┌──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┐
│                                                   TERMS OF USE: MIT License                                                  │                                                            
├──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┤
│Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation    │ 
│files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    │
│modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software│
│is furnished to do so, subject to the following conditions:                                                                   │
│                                                                                                                              │
│The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.│
│                                                                                                                              │
│THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          │
│WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         │
│COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   │
│ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         │
└──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┘
 */
