// automatically generated by spin2cpp v3.8.6-beta on Fri Aug 24 19:07:53 2018
// command line: spin2cpp --ccode --main -L /Users/altergator/Documents/PropSpinCode/SpinObjects apa102-Demo.spin 

/*       
************************************************
* APA102 LED SPI Spin Demo                v0.1 *
*                                              *
* Based on:                                    *
* Propeller SPI Spin Demo                 v1.0 *
* Author: Beau Schwabe                         *
* Copyright (c) 2009 Parallax                  *
* See end of file for terms of use.            *
************************************************
 */
#include <propeller.h>
#include "apa102-Demo.h"

#ifdef __GNUC__
#define INLINE__ static inline
#else
#define INLINE__ static
#define waitcnt(n) _waitcnt(n)
#define coginit(id, code, par) _coginit((unsigned)(par)>>2, (unsigned)(code)>>2, id)
#define cognew(code, par) coginit(0x8, (code), (par))
#define cogstop(i) _cogstop(i)
#endif

void Apa102_demo_APA102_DEMO(Apa102_demo *self)
{
  int32_t 	DO, CO, i;
  /* 
      
  --------------------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------------------
        
  --------------------------------------------------------------------------------------------------------
  --------------------------------------------------------------------------------------------------------
  
  APA102C Schematic:
  
                 ┌─────────┐       |        ┌─────────┐
    P0──>  ──DI──┤1       6├──D0  [|] ──DI──┤1       6├──D0
                 │         │       |        │         │
    P1──>  ──CI──┤2 LED 1  ├──C0  [|] ──CI──┤2 LED 2 5├──C0   ──> Next LED...
                 │         │       |        │         │
    GND──> ──GND─┤3   VCC 4├──┐   [|] ──GND─┤3   VCC 4├─┐
                 └─────────┘  │    |        └─────────┘ │
    +5V──> ───────────────────┘─────────────────────────┘──>
            
   */
  // -----[ Initialization ]--------------------------------------------------
  // Serial communication Setup
  // Initialize serial communication to the PC through the USB connector
  // To view Serial data on the PC use the Parallax Serial Terminal (PST) program.
  printf("APA102C Startup\n\n");
  // SPI Setup
  // SPI.start(ClockDelay, ClockState)
  //    SPI.start(25,1)           '' Initialize SPI Engine with Clock Delay of 15us and Clock State of 1
  // Initialize SPI Engine with Clock Delay of 15us and Clock State of 1
  SPI_Asm_start(&self->SPI, 25, 1);
  // APA102C Setup
  // Set APA102C Data Pin, goes to 1st LED's DI (data in) pin
  DO = 3;
  // Set APA102C Clock Pin, goes to 1st LED's CI (cloack in) pin
  CO = 4;
  //
  printf("APA102C Test!!\n\n");
  // Pause for 5s
  waitcnt(CNT + ((CLKFREQ * 10) / 100));
  while (1) {
    Apa102_demo_Loop(self, DO, CO);
  }
}

void Apa102_demo_Loop(Apa102_demo *self, int32_t loopDO, int32_t loopCO)
{
  int32_t 	i, _idx__0001, _idx__0002, _idx__0003, _idx__0004, _idx__0005;
  //    Bluish Green                                                                            
  // start frame
  SPI_Asm_SHIFTOUT(&self->SPI, loopDO, loopCO, SPI_ASM_MSBFIRST, 32, APA102_DEMO_START_FRAME);
  printf("Bluish Green - LEDs on\n\n");
  for(_idx__0001 = 0; _idx__0001 < (APA102_DEMO_LED_COUNT / 3); _idx__0001++) {
    // test Red RGB frame
    SPI_Asm_SHIFTOUT(&self->SPI, loopDO, loopCO, SPI_ASM_MSBFIRST, 32, APA102_DEMO_GREEN_LED_FRAME);
    // test Red RGB frame
    SPI_Asm_SHIFTOUT(&self->SPI, loopDO, loopCO, SPI_ASM_MSBFIRST, 32, APA102_DEMO_BLUE_LED_FRAME);
    // test Red RGB frame
    SPI_Asm_SHIFTOUT(&self->SPI, loopDO, loopCO, SPI_ASM_MSBFIRST, 32, APA102_DEMO_GREEN_LED_FRAME);
  }
  //
  i = 0;
  while (i < APA102_DEMO_LED_COUNT) {
    // end frame
    SPI_Asm_SHIFTOUT(&self->SPI, loopDO, loopCO, SPI_ASM_MSBFIRST, 8, APA102_DEMO_END_BYTE);
    i = i + 3;
  }
  // Pause for 1s
  waitcnt(CNT + ((CLKFREQ * 100) / 100));
  //    RedGreenBlue
  // start frame
  SPI_Asm_SHIFTOUT(&self->SPI, loopDO, loopCO, SPI_ASM_MSBFIRST, 32, APA102_DEMO_START_FRAME);
  printf("RedGreenBlue - LEDs on\n\n");
  for(_idx__0002 = 0; _idx__0002 < (APA102_DEMO_LED_COUNT / 3); _idx__0002++) {
    // test Red RGB frame
    SPI_Asm_SHIFTOUT(&self->SPI, loopDO, loopCO, SPI_ASM_MSBFIRST, 32, APA102_DEMO_RED_LED_FRAME);
    // test Red RGB frame
    SPI_Asm_SHIFTOUT(&self->SPI, loopDO, loopCO, SPI_ASM_MSBFIRST, 32, APA102_DEMO_GREEN_LED_FRAME);
    // test Red RGB frame
    SPI_Asm_SHIFTOUT(&self->SPI, loopDO, loopCO, SPI_ASM_MSBFIRST, 32, APA102_DEMO_BLUE_LED_FRAME);
  }
  i = 0;
  while (i < APA102_DEMO_LED_COUNT) {
    // end frame
    SPI_Asm_SHIFTOUT(&self->SPI, loopDO, loopCO, SPI_ASM_MSBFIRST, 8, APA102_DEMO_END_BYTE);
    i = i + 3;
  }
  // Pause for 1s
  waitcnt(CNT + ((CLKFREQ * 10) / 100));
  //    Do something interesting!!!
  // start frame
  SPI_Asm_SHIFTOUT(&self->SPI, loopDO, loopCO, SPI_ASM_MSBFIRST, 32, APA102_DEMO_START_FRAME);
  printf("Red & Blue - LEDs on\n\n");
  for(_idx__0003 = 0; _idx__0003 < (APA102_DEMO_LED_COUNT / 3); _idx__0003++) {
    // test Red RGB frame
    SPI_Asm_SHIFTOUT(&self->SPI, loopDO, loopCO, SPI_ASM_MSBFIRST, 32, APA102_DEMO_RED_LED_FRAME);
    // test Red RGB frame
    SPI_Asm_SHIFTOUT(&self->SPI, loopDO, loopCO, SPI_ASM_MSBFIRST, 32, APA102_DEMO_OFF_LED_FRAME);
    // test Red RGB frame
    SPI_Asm_SHIFTOUT(&self->SPI, loopDO, loopCO, SPI_ASM_MSBFIRST, 32, APA102_DEMO_BLUE_LED_FRAME);
  }
  i = 0;
  while (i < APA102_DEMO_LED_COUNT) {
    // end frame
    SPI_Asm_SHIFTOUT(&self->SPI, loopDO, loopCO, SPI_ASM_MSBFIRST, 8, APA102_DEMO_END_BYTE);
    i = i + 3;
  }
  // Pause for 1s
  waitcnt(CNT + ((CLKFREQ * 10) / 100));
  //        
  printf("Low RGB - LEDs on\n\n");
  // start frame
  SPI_Asm_SHIFTOUT(&self->SPI, loopDO, loopCO, SPI_ASM_MSBFIRST, 32, APA102_DEMO_START_FRAME);
  for(_idx__0004 = 0; _idx__0004 < (APA102_DEMO_LED_COUNT / 3); _idx__0004++) {
    // test Red RGB frame
    SPI_Asm_SHIFTOUT(&self->SPI, loopDO, loopCO, SPI_ASM_MSBFIRST, 32, APA102_DEMO_DARK_RED_FRAME);
    // test Red RGB frame
    SPI_Asm_SHIFTOUT(&self->SPI, loopDO, loopCO, SPI_ASM_MSBFIRST, 32, APA102_DEMO_DARK_GREEN_FRAME);
    // test Red RGB frame
    SPI_Asm_SHIFTOUT(&self->SPI, loopDO, loopCO, SPI_ASM_MSBFIRST, 32, APA102_DEMO_DARK_BLUE_FRAME);
  }
  //
  i = 0;
  while (i < APA102_DEMO_LED_COUNT) {
    // end frame
    SPI_Asm_SHIFTOUT(&self->SPI, loopDO, loopCO, SPI_ASM_MSBFIRST, 8, APA102_DEMO_END_BYTE);
    i = i + 3;
  }
  // Pause for 1s
  waitcnt(CNT + ((CLKFREQ * 10) / 100));
  //        
  printf("All LEDs Off\n\n");
  // start frame
  SPI_Asm_SHIFTOUT(&self->SPI, loopDO, loopCO, SPI_ASM_MSBFIRST, 32, APA102_DEMO_START_FRAME);
  for(_idx__0005 = 0; _idx__0005 < APA102_DEMO_LED_COUNT; _idx__0005++) {
    // test Red RGB frame
    SPI_Asm_SHIFTOUT(&self->SPI, loopDO, loopCO, SPI_ASM_MSBFIRST, 32, APA102_DEMO_OFF_LED_FRAME);
    // test Red RGB frame
    SPI_Asm_SHIFTOUT(&self->SPI, loopDO, loopCO, SPI_ASM_MSBFIRST, 32, APA102_DEMO_OFF_LED_FRAME);
    // test Red RGB frame
    SPI_Asm_SHIFTOUT(&self->SPI, loopDO, loopCO, SPI_ASM_MSBFIRST, 32, APA102_DEMO_OFF_LED_FRAME);
  }
  //
  i = 0;
  while (i < APA102_DEMO_LED_COUNT) {
    // end frame
    SPI_Asm_SHIFTOUT(&self->SPI, loopDO, loopCO, SPI_ASM_MSBFIRST, 8, APA102_DEMO_END_BYTE);
    i = i + 3;
  }
  // Pause for 5s
  waitcnt(CNT + ((CLKFREQ * 100) / 100));
}

void Apa102_demo_HIGH(int32_t Pin)
{
  DIRA |= (1 << Pin);
  OUTA |= (1 << Pin);
}

void Apa102_demo_LOW(int32_t Pin)
{
  DIRA |= (1 << Pin);
  OUTA &= (~(1 << Pin));
}

/* 
┌──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┐
│                                                   TERMS OF USE: MIT License                                                  │                                                            
├──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┤
│Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation    │ 
│files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    │
│modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software│
│is furnished to do so, subject to the following conditions:                                                                   │
│                                                                                                                              │
│The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.│
│                                                                                                                              │
│THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          │
│WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         │
│COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   │
│ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         │
└──────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────────┘
 */
/*
__asm__( "    .global __clkfreqval\n" );
__asm__( "    __clkfreqval = 0x5b8d800\n" );
__asm__( "    .global __clkmodeval\n" );
__asm__( "    __clkmodeval = 0x6e\n" );
*/

Apa102_demo MainObj__;

int main() {
  Apa102_demo_APA102_DEMO(&MainObj__);
  return 0;
}
